package service

import (
	"errors"

    "github.com/go-admin-team/go-admin-core/sdk/service"
	"gorm.io/gorm"

	"go-admin/app/operate/models"
	"go-admin/app/operate/service/dto"
	"go-admin/common/actions"
	cDto "go-admin/common/dto"
)

type OrgTeamUser struct {
	service.Service
}

// GetPage 获取OrgTeamUser列表
func (e *OrgTeamUser) GetPage(c *dto.OrgTeamUserGetPageReq, p *actions.DataPermission, list *[]models.OrgTeamUser, count *int64) error {
	var err error
	var data models.OrgTeamUser

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("OrgTeamUserService GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取OrgTeamUser对象
func (e *OrgTeamUser) Get(d *dto.OrgTeamUserGetReq, p *actions.DataPermission, model *models.OrgTeamUser) error {
	var data models.OrgTeamUser

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service GetOrgTeamUser error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建OrgTeamUser对象
func (e *OrgTeamUser) Insert(c *dto.OrgTeamUserInsertReq) error {
    var err error
    var data models.OrgTeamUser
    c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("OrgTeamUserService Insert error:%s \r\n", err)
		return err
	}
	return nil
}

// Update 修改OrgTeamUser对象
func (e *OrgTeamUser) Update(c *dto.OrgTeamUserUpdateReq, p *actions.DataPermission) error {
    var err error
    var data = models.OrgTeamUser{}
    e.Orm.Scopes(
            actions.Permission(data.TableName(), p),
        ).First(&data, c.GetId())
    c.Generate(&data)

    db := e.Orm.Save(&data)
    if db.Error != nil {
        e.Log.Errorf("OrgTeamUserService Save error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权更新该数据")
    }
    return nil
}

// Remove 删除OrgTeamUser
func (e *OrgTeamUser) Remove(d *dto.OrgTeamUserDeleteReq, p *actions.DataPermission) error {
	var data models.OrgTeamUser

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
        e.Log.Errorf("Service RemoveOrgTeamUser error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权删除该数据")
    }
	return nil
}